package gomod

import (
	//	"io"
	"encoding/json"
	"fmt"
	"net/http"
	"io/ioutil"
	"path/filepath"
	"payease_wallet/models"
	"payease_wallet/utils"
)

//二级商户提现提交
func WithdrawRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	apiurl := "https://apis.5upay.com/wallet/withdraw"
	//pfx私钥
	privatepfxpath, pfxerr := filepath.Abs("src/payease_wallet/package/client.pfx")
	if pfxerr != nil {
		fmt.Println("pfxerr:", pfxerr)
	}
	pfxpwd := "123456"
	//cer公钥
	publiccerpath, cererr := filepath.Abs("src/payease_wallet/package/payease.cer")
	if cererr != nil {
		fmt.Println("cererr:", cererr)
	}
	var aesKeyValue string = utils.GetRandomString(16)
	r.ParseForm()
	var order models.Wallet
	order.MerchantId = utils.IsNull(r.Form["merchantId"])//二级商户号
	order.RequestId = utils.IsNull(r.Form["requestId"])   //订单编号 
	order.PartnerId = utils.IsNull(r.Form["partnerId"])   //服务商编号  主商户编号 
    order.WithdrawAmount = utils.IsNull(r.Form["withdrawAmount"])   //提现金额
    order.NotifyUrl = utils.IsNull(r.Form["notifyUrl"])//通知地址
    
	//把订单对象数据转JSON字符串
	orderdata, err := json.Marshal(order)
	if err != nil {
		fmt.Printf(err.Error())
		return
	}
	//fmt.Println("orderdata:", string(orderdata))
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
		fmt.Println("oerr:", oerr)
	}
	//fmt.Println("sortdata:", sortdata)
	hm := utils.Sha1(sortdata)
	hmac, err := utils.Sign(hm, privatepfxpath, pfxpwd)
	if err != nil {
		fmt.Println("err:", err)
	}
	order.Hmac = hmac
	orderjson, err := json.Marshal(order)
	if err != nil {
		fmt.Printf(err.Error())
		return
	}
	encryptKey, enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
		fmt.Println("err:", enerr)
	}
	aesdata, aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
		fmt.Println("err:", aeserro)
	}
	response, rperr := utils.Post(apiurl, encryptKey, order.MerchantId, order.RequestId,order.PartnerId, aesdata, privatepfxpath, pfxpwd)
	if rperr != nil {
		fmt.Println("rperr:", rperr)
	}
	var back models.WalletBack
	json.Unmarshal([]byte(response), &back)
	rhmac := back.Hmac
	//fmt.Println("rhmac:", rhmac)
	if rhmac != "" {
		sortdeldata, oerr := utils.GetDelJson(string(response), "hmac")
		if oerr != nil {
			fmt.Println("oerr:", oerr)
		}
		signhm := utils.Sha1(sortdeldata)
		verr := utils.VerifySign(signhm, publiccerpath, rhmac)
		if verr == nil {
			status := back.Status
			if status == "SUCCESS" {
				fmt.Println("提交成功!")
				fmt.Println("response:", response)
				fmt.Fprintf(w, "提交成功:"+status)
				fmt.Fprintf(w, "\n"+response)
			}else {
				fmt.Println("提交异常:", status)
				fmt.Println("response:", response)
				fmt.Fprintf(w, "提交异常:"+status)
				fmt.Fprintf(w, "\n"+response)
			}
		} else {
			fmt.Println("verr:", verr)
			fmt.Fprintf(w, "验签异常!")
		}
	} else {
		fmt.Println("response:", response)
		fmt.Fprintf(w, response)
	}
}

//异步返回内容处理
func WithdrawNotify(w http.ResponseWriter, r *http.Request) {
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_wallet/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_wallet/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 }
	 r.ParseForm()
	 rpencryptKey := utils.IsNull(r.Header["Encryptkey"])
     if rpencryptKey != "" {		
		aeskey,err := utils.PrivateDecrypt(rpencryptKey, privatepfxpath, pfxpwd)
		if err != nil {
		  fmt.Println("perr:", err)
	   }	
		body, err := ioutil.ReadAll(r.Body)
	   if err != nil {
	     fmt.Println("berr:", err)
	   }  
	   var rback utils.ResponseBack
       json.Unmarshal(body, &rback)
	   ret,err := utils.AesECBDecrypt(rback.Data,aeskey)
	   if err != nil {
		  fmt.Println("aerr:", err)
	   }
	   var orderbacks models.WalletBacks
		json.Unmarshal([]byte(ret), &orderbacks)
		rhmac := orderbacks.Hmac
		//fmt.Println("rhmac:", rhmac)
		if 	rhmac != ""{
			sortdeldata, oerr := utils.GetDelJson(string(ret),"hmac")
			if oerr != nil {
				fmt.Println("oerr:", oerr)
			} 
			signhm := utils.Sha1(sortdeldata)
			verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
			if verr == nil {
				fmt.Fprintf(w, "SUCCESS")
				fmt.Println("通知成功!")
				fmt.Println("ret:", ret)
			}else{
				fmt.Println("verr:", verr)
			}
		}else{
			fmt.Println("response:", ret)
		}
	}else{
		fmt.Println("NO Data")
	}  
	 return
}

//二级商户提现查询
func WithdrawQueryRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	apiurl := "https://apis.5upay.com/wallet/withdrawQuery"
	//pfx私钥
	privatepfxpath, pfxerr := filepath.Abs("src/payease_wallet/package/client.pfx")
	if pfxerr != nil {
		fmt.Println("pfxerr:", pfxerr)
	}
	pfxpwd := "123456"
	//cer公钥
	publiccerpath, cererr := filepath.Abs("src/payease_wallet/package/payease.cer")
	if cererr != nil {
		fmt.Println("cererr:", cererr)
	}
	var aesKeyValue string = utils.GetRandomString(16)
	r.ParseForm()
	var order models.WithdrawQuery
	order.MerchantId = utils.IsNull(r.Form["merchantId"]) //二级商户号
    order.RequestId = utils.IsNull(r.Form["requestId"])   //订单编号 
    order.PartnerId = utils.IsNull(r.Form["partnerId"])   //服务商编号  主商户编号 
	
	//fmt.Println("order:", order)
	//把订单对象数据转JSON字符串
	orderdata, err := json.Marshal(order)
	if err != nil {
		fmt.Printf(err.Error())
		return
	}
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
		fmt.Println("oerr:", oerr)
	}
	hm := utils.Sha1(sortdata)
	hmac, err := utils.Sign(hm, privatepfxpath, pfxpwd)
	if err != nil {
		fmt.Println("err:", err)
	}
	order.Hmac = hmac
	orderjson, err := json.Marshal(order)
	if err != nil {
		fmt.Printf(err.Error())
		return
	}
	encryptKey, enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
		fmt.Println("err:", enerr)
	}
	aesdata, aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
		fmt.Println("err:", aeserro)
	}
	response, rperr := utils.Post(apiurl, encryptKey, order.MerchantId, order.RequestId, order.PartnerId,aesdata, privatepfxpath, pfxpwd)
	if rperr != nil {
		fmt.Println("rperr:", rperr)
	}
	var back models.WithdrawQueryBack
	json.Unmarshal([]byte(response), &back)
	rhmac := back.Hmac
	//fmt.Println("rhmac:", rhmac)
	if rhmac != "" {
		sortdeldata, oerr := utils.GetDelJson(string(response), "hmac")
		if oerr != nil {
			fmt.Println("oerr:", oerr)
		}
		signhm := utils.Sha1(sortdeldata)
		verr := utils.VerifySign(signhm, publiccerpath, rhmac)
		if verr == nil {
			fmt.Println("查询成功!")
			fmt.Println("response:", response)
			fmt.Fprintf(w, "查询成功！")
			fmt.Fprintf(w, "\n"+response)
		} else {
			fmt.Println("verr:", verr)
			fmt.Fprintf(w, "验签异常")
			fmt.Fprintf(w, "\n"+response)
		}
	} else {
		fmt.Println("response:", response)
		fmt.Fprintf(w, response)
	}
}